文章目录

题目链接:

http://codeforces.com/contest/1076/problem/D

题意:N个点,M条边,选择K条边留下来,使得留下来的这些节点到1号点的最短路不变,并且要使留下来的点最多

因为要连成一颗树,所以最多就是K+1个节点,跑个Dij,然后顺着选K个点就行了
这道题最大的收获是:堆优化的Dij也会被卡,要标记看是不是在队列里面,以前不是一直说不用标记啥的嘛,也没出现过问题,结果今天。。。幸好彭老板先补这道题,然后找出问题所在T_T
看别人的代码直接用set了,不在队列里就直接erase了

#include"bits/stdc++.h"
using namespace std;
typedef long long LL;
const int maxn=1e6+5;
const int MOD=1e9+7;
LL inf=1e15;
int N,M,K;
int Pre[maxn];
struct Edge
{
	LL t,v,nxt,id;
	Edge() {}
	Edge(LL t,LL v):t(t),v(v) {}
	Edge(LL t,LL v,LL id):t(t),v(v),id(id) {}
	bool operator<(const Edge tp)const
	{
		return v>tp.v;
	}
};
Edge E[maxn<<2];
int head[maxn<<1];
int tot;
void AddEdge(int aa,int bb,LL val,LL id)
{
	E[++tot].t=bb;
	E[tot].id=id;
	E[tot].v=val;
	E[tot].nxt=head[aa];
	head[aa]=tot;
}
priority_queue<Edge>que;
LL dis[maxn<<1];
void Dij(int st)
{
	while(!que.empty())que.pop();
	for(int i=1; i<=N+M; i++)dis[i]=inf;
	dis[st]=0;
	que.push(Edge(st,0));
	while(!que.empty())
	{
		int u=que.top().t;
		que.pop();
		for(int i=head[u]; i!=-1; i=E[i].nxt)
		{
			int t=E[i].t;
			int v=E[i].v;
			if(dis[u]+v<dis[t])
			{
				Pre[t]=u;
				dis[t]=dis[u]+v;
				que.push(Edge(t,dis[t]));
			}
		}
	}
}
vector<int>ans;
void dfs(int u,int pre)
{
	for(int i=head[u];i!=-1;i=E[i].nxt)
	{
		LL t=E[i].t;
		if(t==pre)continue;
		if(Pre[t]!=u)continue;
		int id=E[i].id;
		
		if(K>0)
		{
			K--;
			ans.push_back(id);
			dfs(t,u);
		}
	}
}
int main()
{
	while(cin>>N>>M>>K)
	{
		ans.clear();
		tot=0;
		memset(head,-1,sizeof head);
		for(LL i=1;i<=M;i++)
		{
			int u,v;
			LL w;
			scanf("%d%d%I64d",&u,&v,&w);
			AddEdge(u,v,w,i);
			AddEdge(v,u,w,i);
		}
		Dij(1);
		vector<int>tp;
		dfs(1,-1);
		cout<<ans.size()<<endl;
		for(int i=0;i<ans.size();i++)cout<<ans[i]<<" ";
		cout<<endl;
	}
}

*/